var oc3board =
{
  // return global rect coords of visible part of current window
  getGlobalDocumentCoords: function()  
  {
    window.alert("visible part2");   
    // top, left, width, height
    var t, l, w, h;    
    
    window.alert("visible part2");   
    l = window.screenX;
    t = window.screenY;
    window.alert("visible part" + l + t);   
    w = document.documentElement.clientWidth;
    h = document.documentElement.clientHeight;
    
    alert(t.toString() + ";" + l.toString() + ";" + w.toString() + ";" + h.toString());
    return {
              top: t,
              left: l,
              width: w,
              height: h
            }; 
  },  
  
  onToolbarButtonCommand: function(e)
  {    
     if(e.originalTarget.id == "oc3board-full-page-capture-button")
     {      
        var canvas = oc3board.screenshoot.makeFullScreenshoot();        
        var filename = "C:\\Windows\\Temp\\oc3board_web_page_" + new Date().getTime() + ".png";
        try
        {
          oc3board.downloadFile(canvas.toDataURL("image/png", ""), filename);
        }
        catch (e)
        {
          alert(e);
        }
        oc3board.launchApplication(e, ["--background", filename,
                                       "--web", window.content.location.toString()]);        
     }
     else if(e.originalTarget.id == "oc3board-visible-page-capture-button")
     {
        var canvas = oc3board.screenshoot.makeVisibleScreenshoot();      
        var filename = "C:\\Windows\\Temp\\oc3board_web_page_" + new Date().getTime() + ".png";
        try
        {
          oc3board.downloadFile(canvas.toDataURL("image/png", ""), filename);
        }
        catch (e)
        {
          alert(e);
        }
        oc3board.launchApplication(e, ["--background", filename,
                                       "--web", window.content.location.toString()]);
        
     }
     else if(e.originalTarget.id == "oc3board-entire-screen-capture-button")
     {
        oc3board.launchApplication(e, ["--capture", "fullscreen"]);
     } 
     else if(e.originalTarget.id == "oc3board-publish-document")
     {
        //var formData = new FormData();
        
        //formData.append("id", "868");
        //formData.append("file", "c:\\folder\\file.extension");
        //formData.append("pt", "announce_text");
        //formData.append("dt", "detailed_text");
        
        //gBrowser.selectedTab = gBrowser.addTab("http://oc3.ru/products/oc3board2/interface/form.php");
        oc3board.openAndReuseOneTabPerAttribute("oc3board-tab-attr-form", "http://oc3.ru/products/oc3board2/interface/form.php");
     }
     else if(e.originalTarget.id == "oc3board-about")
     {
        window.showModalDialog("chrome://oc3board/content/about_dialog.xul");      
        
        return;
        
        var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
        file.initWithPath("d:\\projects\\command_line_tester\\Debug\\cmd_line_pro.exe");
        
        var process = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess);
        process.init(file);
        
        var observer = new processTerminateObserver();
   
        var args = [];         
        process.runAsync(args, args.length, observer, false);  
     }
     else if(e.originalTarget.id.indexOf("oc3board-recent-document-all") > -1)
     {
        //var formData = new FormData();
        
        //formData.append("data", "value");
        
        //gBrowser.selectedTab = gBrowser.addTab("http://oc3.ru/products/oc3board2/interface/list.php")
        //oc3board.postDataToNewTab("http://oc3.ru/products/oc3board2/interface/list.php", formData);
        oc3board.openAndReuseOneTabPerAttribute("oc3board-tab-attr-list", "http://oc3.ru/products/oc3board2/interface/list.php");
     }
     else if(e.originalTarget.id.indexOf("oc3board-recent-document") > -1)
     {
        var aUrl = e.originalTarget.getAttribute("tag");
        //var aFileName = oc3board.getUniqueFileName("downloaded.oc3board");
        var aFileName = oc3board.getUniqueFileName(oc3board.getFileName(aUrl));
        oc3board.downloadFile(aUrl, aFileName, true);
     }
     else
     {
        oc3board.launchApplication(e);
     }    
  },
  
  launchApplication : function(e, args)
  {
    var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
    var osString = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime).OS;
    
    if ("WINNT" == osString)
    {
      var registry = Components.classes["@mozilla.org/windows-registry-key;1"].createInstance(Components.interfaces.nsIWindowsRegKey);
      registry.open(registry.ROOT_KEY_LOCAL_MACHINE, "SOFTWARE\\Classes", registry.ACCESS_READ);
      
      if (registry.hasChild("oc3board2"))
      {
        registry.open(registry.ROOT_KEY_LOCAL_MACHINE, "SOFTWARE\\Classes\\oc3board2\\shell\\open\\command", registry.ACCESS_READ);
        var path = registry.readStringValue("");
        path = path.replace(/\\/g,"\\\\");
        path = path.replace(/"/g,"");
        file.initWithPath(path);
      } else
      {
        var strbundle = document.getElementById("oc3board-strings");
        var localizedString = strbundle.getString("oc3board.notInstalled");
        window.alert(localizedString);
        return
      }
    } else   
    {
      file.initWithPath("/usr/bin/oc3board");
    }
    
    try
    {    
      var process = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess);
      process.init(file);
    
      // If first param is true, calling thread will be blocked until called process terminates
      if (args == null)
        args = [];
      //if (screenPath != null) args = ["--background", screenPath];
      process.run(false, args, args.length);      
    } catch (error)
    {
      var strbundle = document.getElementById("oc3board-strings");
      var localizedString = strbundle.getString("oc3board.notInstalledCorrectly");
      window.alert(localizedString);
    }
  },
 
  insertButtonInToolbar : function(str_button)
  {
    try
    {
      
      var box = document.getElementById('nav-bar');
      if (box)
      {	
        var newset;
        if (box.getAttribute('currentset') && box.getAttribute('currentset').indexOf(str_button) == -1)
        {
          box.insertItem (str_button, null, null, false);
          newset=box.getAttribute('currentset') + ',' + str_button;
          box.setAttribute('currentset', newset);
          document.persist('nav-bar', 'currentset');
          BrowserToolboxCustomizeDone(true);
        }
        else
        {
          if (box.getAttribute('currentset').indexOf(str_button) == -1)
          {
            box.insertItem (str_button, null, null, false);
            newset=box.getAttribute('defaultset') + ',' + str_button;
            box.setAttribute('currentset', newset);
            document.persist('nav-bar', 'currentset');
            BrowserToolboxCustomizeDone(true);							
          }
        }
      }	   
    }
    catch(e)
    {
            //alert(e);        
    }
  },
  
  getFileName: function (url)
  {
    var fname = url;
    fname = fname.substring(0, (fname.indexOf("#") == -1) ? fname.length : fname.indexOf("#"));
    fname = fname.substring(0, (fname.indexOf("?") == -1) ? fname.length : fname.indexOf("?"));
    fname = fname.substring(fname.lastIndexOf("/") + 1, fname.length);
    return fname;
  },
  
  onLoad: function()
  {
    // initialization code
    this.initialized = true;
    this.strings = document.getElementById("oc3board-strings");
  
    oc3board.insertButtonInToolbar("oc3board-toolbar-button");  
    //if (!oc3board.Java.loadJumpLoaderApplet())
    {
       //alert("loading upload applet failed");
    }
  
    oc3board.User.update();
    observer = new myObserver();
    
    //window.addEventListener("load", function () { oc3board.onPageLoad(); }, false);
    gBrowser.addEventListener("DOMContentLoaded", oc3board.onPageLoad, false);
  },

  onMenuItemCommand: function(e)
  {
    var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
    promptService.alert(window, this.strings.getString("helloMessageTitle"), this.strings.getString("helloMessage"));
  },  
  
  launchFile: function(aFileName)
  {
    var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
    file.initWithPath(aFileName);
    var process = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess);
    process.init(file);
  
    // If first param is true, calling thread will be blocked until called process terminates    
    var args = [];      
    process.run(false, args, args.length);            
   },
 
  uploadFile: function(file, posturl)
  {
    var windowObjectReference;
    windowObjectReference = window.open("chrome://oc3board/content/progress_dialog.xul", "xulschoolhello-some-window", "chrome,centerscreen");
    
    netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
    
    var xhr = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"].createInstance(Components.interfaces.nsIXMLHttpRequest);
    xhr.open("POST", posturl, true);
        
    xhr.upload.addEventListener("progress", function(e) {
          if (e.lengthComputable)
          {          
            var percentage = Math.round((e.loaded * 100) / e.total);
            windowObjectReference.document.getElementById("progress_meter_id").value = percentage;
            /*
            let alertsService = Cc["@mozilla.org/alerts-service;1"].getService(Ci.nsIAlertsService);
            let title = "title";
            let message = percentage;
            alertsService.showAlertNotification("", title, message);
            */
          }
        }, false);

    
    xhr.upload.addEventListener("load", function(e){
            //self.ctrl.update(100);
            //var canvas = self.ctrl.ctx.canvas;
            //canvas.parentNode.removeChild(canvas);
            windowObjectReference.close();
        }, false);        
        
    xhr.setRequestHeader("Cache-Control", "no-cache");
    xhr.setRequestHeader("X-Requested-With", "XMLHttpRequest");
    xhr.setRequestHeader("X-File-Name", file.leafName);
    xhr.setRequestHeader("X-File-Size", file.fileSize);
    xhr.setRequestHeader("Content-Type", "multipart/form-data");
    //xhr.overrideMimeType('text/plain; charset=x-user-defined-binary');
    //xmlhttpUpload.setRequestHeader("Content-Type", "text/plain"); 
    
    /*
    var multiplexStream = Components.classes["@mozilla.org/io/multiplex-input-stream;1"].createInstance(Components.interfaces.nsIMultiplexInputStream);

    var stringStream = Components.classes["@mozilla.org/io/string-input-stream;1"].createInstance(Components.interfaces.nsIStringInputStream);
    stringStream.setData("\r", 2);
    */
    
    var fileStream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
    fileStream.init(file, 0x01, 0444, null);
    //fileStream.init(file, 0x04 | 0x08, 0644, 0x04); // file is an nsIFile instance   
        
        
    //multiplexStream.appendStream(stringStream);
    //multiplexStream.appendStream(fileStream);
    
    //var bufferedStream = Components.classes["@mozilla.org/network/buffered-input-stream;1"].createInstance(Components.interfaces.nsIBufferedInputStream);    
    //bufferedStream.init(fileStream, 1024);
    
    xhr.send(fileStream);
  },
  
  downloadFile: function(aURLToDownload, aFileName, launchAfterFinished)
  {
    if (launchAfterFinished == undefined)
      launchApplication = false;
      
    var persist = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"].createInstance(Components.interfaces.nsIWebBrowserPersist);
    var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
    file.initWithPath(aFileName); // download destination
    var obj_URI = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newURI(aURLToDownload, null, null);
    
    persist.progressListener =
    {
       onProgressChange: function(aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress)
       {
          //var percentComplete = (aCurTotalProgress/aMaxTotalProgress)*100;
          //var ele = document.getElementById("progress_element");
          //ele.innerHTML = percentComplete +"%";
       },
       
       onStateChange: function(aWebProgress, aRequest, aStateFlags, aStatus)
       {
          if (aStateFlags & persist.progressListener.STATE_STOP)
          {
             if (launchAfterFinished)
             {
                oc3board.launchFile(aFileName);
             }
          }            
          // do something
       }
    }
	
	//var privacyContext = sourceWindow.QueryInterface(Components.interfaces.nsIInterfaceRequestor).getInterface(Components.interfaces.nsIWebNavigation).QueryInterface(nsILoadContext);
    
    persist.saveURI(obj_URI, null, null, null, "", file, null, null);
  },
  
  openAndReuseOneTabPerAttribute: function(attrName, url)
  {
      var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
      for (var found = false, index = 0, tabbrowser = wm.getEnumerator('navigator:browser').getNext().gBrowser; index < tabbrowser.tabContainer.childNodes.length && !found; index++)
      { 
         // Get the next tab
         var currentTab = tabbrowser.tabContainer.childNodes[index];
   
         // Does this tab contain our custom attribute?
         if (currentTab.hasAttribute(attrName))
         {
            // Yes--select and focus it.
            tabbrowser.selectedTab = currentTab;
 
            // Focus *this* browser window in case another one is currently focused
            tabbrowser.ownerDocument.defaultView.focus();
            found = true;
         }
      }

      if (!found)
      {
         // Our tab isn't open. Open it now.
         var browserEnumerator = wm.getEnumerator("navigator:browser");
         var tabbrowser = browserEnumerator.getNext().gBrowser;
  
         // Create tab
         var newTab = tabbrowser.addTab(url);
         newTab.setAttribute(attrName, "xyz");
  
         // Focus tab
         tabbrowser.selectedTab = newTab;
    
         // Focus *this* browser window in case another one is currently focused
         tabbrowser.ownerDocument.defaultView.focus();
      }
  },
  
  postDataToNewTab: function(aURI, aFormData)
  {
      gBrowser.selectedTab = gBrowser.addTab("chrome://oc3board/content/html/loading.html");
     
      var newTabBrowser = gBrowser.getBrowserForTab(gBrowser.selectedTab);
      newTabBrowser.addEventListener("load", function ()
      {
         var req = new XMLHttpRequest();
         req.open("POST", aURI);
         
         req.onreadystatechange = function (aEvt)
         {
            if (req.readyState == 4)
            {
               if(req.status == 200)
                  gBrowser.contentDocument.body.innerHTML = req.responseText;                  
               else
                  gBrowser.contentDocument.body.innerHTML = "Error loading page";
            }
         };
         req.send(aFormData);    
      }, true);
  },
  
  getUniqueFileName: function(aName)
  {
      var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("TmpD", Components.interfaces.nsIFile);
      file.append(aName);
      file.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0666);
      return file.path;
  },
  
  onPageLoad : function(event)
  {
      let doc = event.originalTarget;
      let url = doc.defaultView.location.href;      
      if ((url.indexOf("oc3.ru") != -1))
      {
         if ((url.indexOf("?login") != -1) || (url.indexOf("?logout") != -1))
         {
            oc3board.User.update();
         }
         if (url.indexOf("form.php") != -1)
         {
            oc3board.User.update();
         }         
         //var event = { notify: function(timer) { oc3board.User.update(); } };
         //var timer = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
         //timer.initWithCallback(event, 1000, Components.interfaces.nsITimer.TYPE_ONE_SHOT);  
      }
  }
};

function processTerminateObserver()
{
  
}

processTerminateObserver.prototype =
{
   observe: function(subject, topic, data)
   {
      alert(subject.exitValue); 
   }
}

function myObserver()
{
  this.register();
}

myObserver.prototype =
{
  observe: function(subject, topic, data)
  {
    if ("http-on-modify-request" == topic)
    {
      var httpChannel = subject.QueryInterface(Components.interfaces.nsIHttpChannel);
      //if ((httpChannel.URI.host.indexOf("oc3.ru") != -1) && ((httpChannel.URI.path.indexOf("?login") != -1) || (httpChannel.URI.path.indexOf("?logout") != -1)))
      {
         //alert("got!");
         //oc3board.User.updateIcon();
      }  
    }
  },
  
  register: function()
  {
    var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
    observerService.addObserver(this, "http-on-modify-request", false);
  },
  
  unregister: function()
  {
    var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
    observerService.removeObserver(this, "http-on-modify-request");
  }
}

window.addEventListener("load", function () { oc3board.onLoad(); }, false);